//*********************************** class Palette() *********************************************************
class Palette {
    final Pave palettes[][] = new Pave[2*c_max][2*l_max];
    Pave palette;
    
    boolean in_palette  = false;                                                                                                                   //  la souris est dans la palette
    boolean selectionne = false;
    
    Palette() {
        palettes[0][0]  = new NullPave();
        palettes[1][0]  = new NullPave();
        palettes[0][1]  = new PaveDroit();
        palettes[1][1]  = new PaveButoir();
        palettes[0][2]  = new PaveArc45();
        palettes[1][2]  = new PaveArc90();
        palettes[0][3]  = new PaveFlexibleSdroit();
        palettes[1][3]  = new PaveFlexibleSgauche();
        palettes[0][6]  = new PaveVoiePont();
        palettes[1][6]  = new PavePont();
        palettes[0][7]  = new PaveCroisement45();
        palettes[1][7]  = new PaveCroisement90();
        palettes[0][8]  = new PaveAiguilleDroite();
        palettes[1][8]  = new PaveAiguilleGauche();
        palettes[0][9]  = new PaveTJS();
        palettes[1][9]  = new PaveTJD();
        palettes[0][10] = new PaveTriple();
        palettes[1][10] = new PaveSymetrique();
    }
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//******************************* Bouton() ******************************
class Bouton {

    Forme[] formes;
    Bouton(Forme... fs) {formes = fs; }  // constructeur   
    Bouton[] boutons   = new Bouton[C_MAX_P]; 
    Bouton bouton;
        
    //--------------------- dessine_bouton() -------------------------
    void dessine_bouton(int _xOffset, int _yOffset, float _x,float _y, float _largeur_tuile, float _hauteur_tuile, float _hauteur_bouton, float _zoom_x, float _zoom_y, String _texte, boolean _selectionne) { 
        noStroke();
        float ordre_i = _x/_largeur_tuile;
        float ordre_j = 6.5F*(_y/_hauteur_tuile-1/5); 
        switch(int(ordre_j)%2) {
            case 0:
                if (_selectionne) {
                    formes[0].dessine_forme_pupitre(_xOffset, _yOffset, ordre_i+1.57F*_largeur_tuile,              _y/_hauteur_tuile+0.02F,              _zoom_x, _zoom_y, AQUA  );       //  bouton on,  gauche
                }
                formes[1].dessine_forme_pupitre(    _xOffset, _yOffset, ordre_i+(1.55F+18F/50F/2F)*_largeur_tuile, _y/_hauteur_tuile+_hauteur_bouton/2F, _zoom_x, _zoom_y, NOIR);         //  texte
                break;
            case 1:
                if (_selectionne) {
                    formes[0].dessine_forme_pupitre(_xOffset, _yOffset, ordre_i+1.13F*_largeur_tuile,              _y/_hauteur_tuile+0.02F,              _zoom_x, _zoom_y, AQUA);        //  bouton on,  droit
                }
                formes[1].dessine_forme_pupitre(    _xOffset, _yOffset, ordre_i+(1.11F+18F/50F/2F)*_largeur_tuile, _y/_hauteur_tuile+_hauteur_bouton/2F, _zoom_x, _zoom_y, NOIR);        //  texte
                break;
        }        
        hauteur_bouton = _hauteur_bouton;
        texte          = _texte;        
    }       

    //---------------------- copy() -------------------------------------------
    Bouton copy() {
        int forme_length = formes.length;
        Forme[] copyFormes;
        copyFormes = new Forme[forme_length];
        for (int i = 0; i < forme_length; i++) {
            copyFormes[i] = formes[i].copy();
        }
        return new Bouton(copyFormes);
    }            
}

//-------------------------- Bouton1() ------------------------------
class Bouton1 extends Bouton {
    Bouton1(int _ordre) {   
        super(new Forme[] {new Bouton_DCC(_ordre), new Bouton_nom(texte)});
    }
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//*************************************** CabSignal() *******************************************************************
class CabSignal {
    
    float a  =  30*largeur_pixel/70;  //  ecart bord - lisere
    float a1 =  50*largeur_pixel/70;  //  largeur lisere
    float b  = 300*largeur_pixel/70;  //  inter-feux principal
    float c  = 280*largeur_pixel/70;  //  inter-feux secondaire
    float c1 = 260*largeur_pixel/70;  //  inter-feux secondaire 1
    float c2 = 500*largeur_pixel/70;  //  inter-feux secondaire 1
    float d  = 410*largeur_pixel/70;  //  rayon feu principal
    float d1 = 380*largeur_pixel/70;  //  rayon feu secondaire
    float e  = 2*d/5;                 //  e = 164
    float f  = e/2;                   //  f = 82
    float g  = 20*largeur_pixel/70;
    
    float diam_220 = 220*largeur_pixel/70;  //  
    float diam_160 = 160*largeur_pixel/70;  //  
    float diam_120 = 120*largeur_pixel/70;  //    
    float xOffset;  //  position generale du cabsignal
    float yOffset;     
    
    //boolean clignotant    = false;
    CabSignal(float _x, float _y) { xOffset = _x; yOffset = _y; }
//------------------------------------------------ dessine_signal() ---------------------------------------------    
    void dessine_signal(int _feu) {
      noStroke();
      switch (_feu) {       
          case ETEINT: break; 
          case VOIE_LIBRE:
              feu_220(VERT, d, (d1+3*b+c2));
              oeilleton();
              break;       
          case AVERTISSEMENT:
              feu_220(JAUNE, d, d1+3*b+c2+c1+c);
              oeilleton();
              break;       
          case SEMAPHORE:
              feu_220(ROUGE, d, d1+3*b+c2+c1);
              oeilleton();
              break;       
          case SEMAPHORE_CLI:
              feu_clignotant_220(ROUGE, d, d1+3*b+c2+c1);
              oeilleton();
              break;       
          case CARRE:
              feu_220(ROUGE, d, d1+2*b, d, d1+3*b+c2+c1);
              break;       
          case MANOEUVRE:
              feu_160(BLANC, d, d1+3*b);
              break;       
          case CARRE_VIOLET:
              feu_220(VIOLET, d, d1+2*b);
              break;       
          case RALENTISSEMENT:
              feu_160(JAUNE, d, d1+b, d+2*b, d1+b);
              oeilleton();
              break;       
          case RALENTISSEMENT_CLI:
              feu_clignotant_160(JAUNE, d, d1+b, d+2*b, d1+b);
              oeilleton();
              break;       
          case RAPPEL_RALENTISSEMENT:
              feu_160(JAUNE, d+2*b, d1, d+2*b, d1+2*b);
              oeilleton();
              break; // combine
          case RAPPEL_RALENTISSEMENT_CLI:
              feu_clignotant_160(JAUNE, d+2*b, d1, d+2*b, d1+2*b);
              oeilleton();
              break;
          case COMBINE:
              feu_220(JAUNE, d, d1+3*b+c2+c1+c);
              feu_160(JAUNE, d+2*b, d, d+2*b, d1+2*b);
              oeilleton();
              break;       
          case COMBINE_CLI:
              feu_220(JAUNE, d, d1+3*b+c2+c1+c);
              feu_clignotant_160(JAUNE, d+2*b, d, d+2*b, d1+2*b);
              oeilleton();
              break;       
          case BUTOIR: 
              feu_220(VIOLET, d, d1+3*b+c2+c1);
              break;
              //rouge sur carre     feu(Color.MAGENTA,45,126); break; violet sur semaphore      
          //case DISQUE: feu(ROUGE,45,69); feu(JAUNE,45,145); break;       
          default: println("ERREUR switch");     
        }    
    }
    
    void feu_220(int _couleur, float _x, float _y) { fill(_couleur); ellipse(xOffset+_x*pupitre.zoom_p, yOffset+_y*pupitre.zoom_p, diam_220*pupitre.zoom_p, diam_220*pupitre.zoom_p); } // 1 feu
    void feu_220(int _couleur, float _x1, float _y1, float _x2, float _y2) { feu_220(_couleur, _x1, _y1); feu_220(_couleur, _x2, _y2); } // 2 feux
      
    void feu_160(int _couleur, float _x, float _y) { fill(_couleur); ellipse(xOffset+_x*pupitre.zoom_p, yOffset+_y*pupitre.zoom_p, diam_160*pupitre.zoom_p, diam_160*pupitre.zoom_p); } // 1 feu
    void feu_160(int _couleur, float _x1, float _y1, float _x2, float _y2) { feu_160(_couleur,_x1,_y1); feu_160(_couleur,_x2,_y2); } // 2 feux

    void feu_clignotant_220(int _couleur, float _x, float _y) { if (cliFeux) fill(NOIR); else fill(_couleur); ellipse(xOffset+_x*pupitre.zoom_p, yOffset+_y*pupitre.zoom_p, diam_220*pupitre.zoom_p, diam_220*pupitre.zoom_p); } // 1 feu
    void feu_clignotant_220(int _couleur, float _x1, float _y1, float _x2, float _y2) { if (cliFeux) fill(NOIR); else fill(_couleur); feu_clignotant_220(_couleur, _x1, _y1); feu_clignotant_220(_couleur, _x2, _y2); } // 2 feux

    void feu_clignotant_160(int _couleur, float _x, float _y) { if (cliFeux) fill(NOIR); else fill(_couleur); ellipse(xOffset+_x*pupitre.zoom_p, yOffset+_y*pupitre.zoom_p, diam_160*pupitre.zoom_p, diam_160*pupitre.zoom_p); } // 1 feu
    void feu_clignotant_160(int _couleur, float _x1, float _y1, float _x2, float _y2) { if (cliFeux) fill(NOIR); else fill(_couleur); feu_clignotant_160(_couleur, _x1, _y1); feu_clignotant_160(_couleur, _x2, _y2); } // 2 feux

    void oeilleton() { fill(BLANC); ellipse(xOffset-0.06F*pupitre.zoom_p, yOffset+(d1+3*b+c2+c1+c+d+e-3*f)*pupitre.zoom_p, diam_120*pupitre.zoom_p, diam_120*pupitre.zoom_p); } // oeilleton
}
