//******************************* Pave() ******************************
class Pave {                                           //                                    A TRANSFERER
    int       c                   = 0;                 //                                    c
    int       l                   = 0;                 //                                    l
    int       type                = 0;                 //                                    type
    int       elongation          = 1;                 //                                    elongation
    int       decalage[]          = new int[4];        //  type -> decalage
    int       orientation         = 1;                 //                                    orientation             donne l'orientation du pavé suite aux rotations (0 à 8)
    int       lames               = 0;                 //                                                            donne la position des lames (0 à 4)
    int       lames_tempo         = 0;                 //                                                            donne la position des lames uniquement à l'affichage des itinéraires potentiels
    int       couleur_rail        = BLANC;             //                                                            couleur rail au TCO (bleu clair/fonce, blanc/gris, vert/rouge)
    boolean   deformable          = false;             //  type -> deformable
    boolean   selectionne         = false;             //                                                            INUTILE ?
    boolean   appareil_de_voie    = false;             //  type -> appareil de voie
    String    ID_zone             = "_";               //                                    ID_zone
    float     longueur_pave       = 0F;                //  type -> longueur pave
    int       manoeuvre           = 0;
    boolean   trouve_cible[]      = new boolean[2];
    boolean   choisi              = false;
    boolean   recopie             = false;
    //-------------------------------- itinéraires -----------------------------------------
    boolean   affiche_iti_tempo   = false;
    int       entree_pave         = 0;                 //                                                            cote par lequel on est rentre dans le pavé en suivant l'itinéraire
    int       entree_pave_tempo   = 0;                 //                                                            cote par lequel on est rentre dans le pavé en suivant l'itinéraire potentiel
    int       lames_affichees     = 0;                 //                                                            lames effectivement affichées
    int       poids               = 0;
    boolean   occupe              = false;             //                                                            occupation du pavé donnee par l'occupation de la zone
    PVector   connecteur[][]      = new PVector[2][4]; //                                                            un connecteur de chaque cote [2] et [4] connecteurs possibles par pave
    int       numero_train1       = 0;
    int       numero_train2       = 0;
    PVector   base0[]             = new PVector[4];
    PVector   base1[]             = new PVector[4];
    PVector   base12[]            = new PVector[4];
    PVector   base13[]            = new PVector[4];
    boolean   bon_pave            = false;
    //-------------------------------- variables des voies flexibles -----------------------
    int       longueur_voie       = 0;                 //                                    longueur_voie
    int       hauteur_voie        = 0;                 //                                    hauteur_voie
    int       deformation         = 0;                 //  elongation -> deformation
    //-------------------------------- variables des voies pont tournant -----------------
    int       ordre               = 0;                 //                                    ordre                   nombre de formes dans le pavé (1 à 4)
    //------------------------------- signaux zone--------------------------------------------
    Pave      pave_signal_zone[]  = new Pave[2];       //                                                            le pavé qui contient le signal de zone, en allant du cote [0] ou [1]
    int       cote_signal_zone[]  = new int[2];        //                                                            c'est le cote [0] ou [1], vu du pavé zone, qui contient le signal de la zone
    Pave      pave_cible_zone[]   = new Pave[2];       //                                                            le pavé qui contient la cible de zone, en allant du cote [0] ou [1]
    int       cote_cible_zone[]   = new int[2];        //                                                            c'est le cote [0] ou [1], vu du pavé zone, qui contient la cible de la zone
    int       code_signal[]       = new int[2];        //                                                            le code signal est CARRE, VOIE LIBRE, ...dans le enum de depart
    //------------------------------- signaux suivants ----------------------------------------
    Pave      pave_signal_suiv[]  = new Pave[2];       //                                                            le pavé signal suivant est le pavé contenant le signal suivant, de chaque cote [2]
    int       cote_signal_suiv[]  = new int[2];        //                                                            c'est le cote [0] ou [1], vu du pavé signal suivant, qui contient le signal suivant
    //------------------------------ corolaires au traitement de signal -----------------------------
    boolean   cible[]             = new boolean[2];    //                                    cible                   donne l'existence ou non d'une cible pour chaque cote du pavé [2]
    boolean   cible_visible[]     = new boolean[2];    //                                    cible_visible           donne la visibilité ou non d'une cible pour chaque cote du pavé [2]
    boolean   butoir[]            = new boolean[2];
    int       feu_si_devie[]      = new int[2];        //                                                            quand on passe d'un signal au signal suivant, on peut passer sur un appareil de voie en position deviee...
                                                       //                                                            ...si cette deviation amene un ralentissement on enregistre ce ralentissement dans le feu_si_devie (= 30, 60 ou 120)
    boolean   feu_clignotant[]    = new boolean[2];    //                                                            feu clignotant
    boolean   mecanique[]         = new boolean[2];    //                                    mecanique               true si le signal est mecanique et false si c'est un signal lumineux
    int       type_cible[]        = new int[2];        //                                    type_cible              en testant tous les itinéraires possibles, on en deduit la cible à choisir
    int       carre_manuel[]      = new int[2];
    boolean   feu_noir[]          = new boolean[2];
    color     couleur_feu[]       = new color[2];      //                                                            couleur_feu ne sert qu'a l'affichage sur le TCO [2] cotes
    boolean   rouge_clignotant[]  = new boolean[2];    //                                                            rouge_clignotant pour entrer dans une zone occupée
    //----------------------------- vitesses ---------------------------------------------
    int       vitesse_deviee      = 1000;              //                                    vitesse_deviee          maxi km/h (= 30, 60, 120) sur l'appareil de voie en voie deviee. Pas de ralentissement = 1000
    int       vitesse_limite      = 0;                 //                                    vitesse_limite          vitesse limite sur la zone en km/h
    
    Zone zone_pave;

    Forme[]      Formes;
    Forme[]      Formes45;
    Pave(Forme[] fms1, Forme[] fms2) {
        Formes      = fms1;
        Formes45    = fms2;
        for (int i = 0; i < 2; i++) {                                                                                                              //  on a un connecteur à gauche et un à droite de chaque forme
            for (int j = 0; j < 4; j++) {                                                                                                          //  on a jusqu'a 4 formes par pave
                connecteur[i][j] = new PVector();
            }
        }
    }  //  constructeur    
    //--------------------------------- couleurs_pave() -------------------------------
    void couleurs_pave() {
        if (selectionne) {
            stroke(ARDOISE);
            fill(ARDOISE);
            rect(0, 0, MAILLE, MAILLE);
        }
        noStroke();
        if (l > L_MAX) {
            if (affiche_iti_tempo) {
                lames_affichees = lames_tempo;
            } else {
                if (occupe) {
                    couleur_rail = ROUGE;
                } else {
                    if (numero_train1 != 0) {
                        lames_affichees = lames;
                        if (numero_train1 > 0) {
                            couleur_rail = VERT;
                        } else {
                            couleur_rail = BLANC;
                        }
                    } else {
                        if ("_".equals(ID_zone)) {
                            couleur_rail = BLEU2;
                        } else {
                            couleur_rail = GRIS;
                        }
                    }
                }
            }
        } else {
            if (affiche_iti_tempo) {
                lames_affichees = lames_tempo;
            } else {
                if (occupe) {
                    couleur_rail = ROUGE;
                } else {
                    if (numero_train1 != 0) {
                        lames_affichees = lames;
                        if (numero_train1 > 0) {
                            couleur_rail = VERT;
                        } else {
                            couleur_rail = BLANC;
                        }
                    } else {
                        if ("_".equals(ID_zone)) {
                            couleur_rail = BLEU1;
                        } else {
                            couleur_rail = GRIS_FONCE;
                        }
                    }
                }
            }
        }
        if (type == 2) { couleur_rail = NOIR; }
    }
    //-------------------------- dessine_pave_debut() -----------------------------
    void dessine_pave_debut(int _c, int _l) {
        couleurs_pave();
        int forme_length = Formes.length;
        if (orientation % 2 == 0) {
            for (int i = 0; i < forme_length; i++) {
                Formes45[i].pave_vers_forme(elongation, orientation, decalage[i], appareil_de_voie, butoir[0], butoir[1],
                                            cible[0], cible[1], cible_visible[0], cible_visible[1]);                                               //  on fait toutes les modifications de formes
                Formes45[i].connecteurs_absolus(_c, _l);                                                                                           //  calcule les coordonnees absolues des connecteurs
                connecteur[0][i].x       = Formes45[i].connecteur_absolu0.x;                                                                       //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][i].y       = Formes45[i].connecteur_absolu0.y;
                connecteur[1][i].x       = Formes45[i].connecteur_absolu1.x;                                                                       //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][i].y       = Formes45[i].connecteur_absolu1.y;
                Formes45[i].retrait0     = connecteur[0][i].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes45[i].retrait1     = connecteur[1][i].z;
                base0[i]                 = Formes45[i].base[0];
                base1[i]                 = Formes45[i].base[1];
                base12[i]                = Formes45[i].base[12];
                base13[i]                = Formes45[i].base[13];
                if (type == 2) {
                    Formes45[i].dessine_forme(NOIR, 3F*RAIL);                                                                                      //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
                } else {
                    if (appareil_de_voie) {
                        Formes45[i].dessine_forme(NOIR, RAIL);                                                                                     //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
                    }
                }
                Formes45[i].dessine_cibles(0);                                                                                                     //  dessine toutes les cibles une seule fois
                Formes45[i].dessine_cibles(1);                                                                                                     //  dessine toutes les cibles une seule fois
            }
        } else {
            for (int i = 0; i < forme_length; i++) {
                Formes[i].pave_vers_forme(elongation, orientation, decalage[i], appareil_de_voie, butoir[0], butoir[1],
                                          cible[0], cible[1], cible_visible[0], cible_visible[1]);                                                 //  on fait toutes les modifications de formes
                Formes[i].connecteurs_absolus(_c, _l);                                                                                             //  calcule les coordonnees absolues des connecteurs
                connecteur[0][i].x       = Formes[i].connecteur_absolu0.x;                                                                         //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][i].y       = Formes[i].connecteur_absolu0.y;
                connecteur[1][i].x       = Formes[i].connecteur_absolu1.x;                                                                         //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][i].y       = Formes[i].connecteur_absolu1.y;
                Formes[i].retrait0       = connecteur[0][i].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes[i].retrait1       = connecteur[1][i].z;
                base0[i]                 = Formes[i].base[0];
                base1[i]                 = Formes[i].base[1];
                base12[i]                = Formes[i].base[12];
                base13[i]                = Formes[i].base[13];
                if (type == 2) {
                    Formes[i].dessine_forme(NOIR, 3F*RAIL);                                                                                        //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
                } else {
                    if (appareil_de_voie) {
                        Formes[i].dessine_forme(NOIR, RAIL);                                                                                       //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
                    }
                }
                Formes[i].dessine_cibles(0);                                                                                                       //  dessine toutes les cibles une seule fois
                Formes[i].dessine_cibles(1);                                                                                                       //  dessine toutes les cibles une seule fois
            }
        }
    }
    //-------------------------- dessine_pave() -----------------------------
    void dessine_pave() {
        couleurs_pave();
        if (orientation % 2 == 0) {
            if ((!itineraire_demande) || affiche_iti_tempo) {
                Formes45[lames_affichees].base[12] = base0[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'itinéraires
                Formes45[lames_affichees].base[13] = base1[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'itinéraires
            } else {
                Formes45[lames_affichees].base[12] = base12[lames_affichees];                                                                      //  on récupère la position avec retrait dans le cas normal
                Formes45[lames_affichees].base[13] = base13[lames_affichees];                                                                      //  on récupère la position avec retrait dans le cas normal
            }
            if (butoir[0]) {
                Formes45[lames_affichees].base[12] = base0[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            if (butoir[1]) {
                Formes45[lames_affichees].base[13] = base1[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            Formes45[lames_affichees].dessine_forme(couleur_rail, RAIL);                                                                           //----- dessine la voie choisie de la couleur_rail et en fonction de la position des lames
            if (butoir[0]) {
                Formes45[lames_affichees].base[12] = base0[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            if (butoir[1]) {
                Formes45[lames_affichees].base[13] = base1[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            longueur_pave                          = Formes45[0].longueur_forme;                                                                   //  recupere dans le pavé la longueur de la forme
        } else {
            if ((!itineraire_demande) || affiche_iti_tempo) {
                Formes[lames_affichees].base[12]   = base0[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'itinéraires
                Formes[lames_affichees].base[13]   = base1[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'itinéraires
            } else {
                Formes[lames_affichees].base[12]   = base12[lames_affichees];                                                                      //  on récupère la position avec retrait dans le cas normal
                Formes[lames_affichees].base[13]   = base13[lames_affichees];                                                                      //  on récupère la position avec retrait dans le cas normal
            }
            if (butoir[0]) {
                Formes[lames_affichees].base[12]   = base0[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            if (butoir[1]) {
                Formes[lames_affichees].base[13]   = base1[lames_affichees];                                                                       //  on impose la position sans retrait dans le cas d'un butoir
            }
            Formes[lames_affichees].dessine_forme(couleur_rail, RAIL);                                                                             //----- dessine la voie choisie de la couleur_rail et en fonction de la position des lames
            longueur_pave                          = Formes[0].longueur_forme;                                                                     //  recupere dans le pavé la longueur de la forme
        }
    }
    //-------------------------- dessine_feu_pave() -----------------------------
    void dessine_feu_pave(int _cote) {
        if (cible_visible[_cote] || feu_noir[_cote]) {
            noStroke();
            strokeWeight(1);
            if (butoir[_cote]) {
                switch (manoeuvre) {
                    case 0 :
                       couleur_feu[_cote] = ROUGE;
                       break;
                    case 1 :
                    case 2 :
                       couleur_feu[_cote] = VIOLET;
                       break;                       
                }
            }
            if (orientation % 2 == 0) {
                Formes45[0].dessine_feux(couleur_feu[_cote], feu_clignotant[_cote], feu_noir[_cote], _cote);                                       //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
            } else {
                Formes[0].dessine_feux(couleur_feu[_cote], feu_clignotant[_cote], feu_noir[_cote], _cote);                                         //  dessine la voie choisie de la couleur_rail en fonction de la position des lames
            }
        }
    }
    //---------------------------------- copy() -----------------------------------
    Pave copy() { 
        int forme_length      = Formes.length;
        Forme[] copyFormes, copyFormes45;
        copyFormes            = new Forme[forme_length];
        copyFormes45          = new Forme[forme_length];
        for (int i = 0; i < forme_length; i++) {
            copyFormes[i]     = Formes[i].copy();
            copyFormes45[i]   = Formes45[i].copy();
        }
        noStroke();
        return new Pave(copyFormes, copyFormes45);
    }
}

//************************************************************** Paves particuliers ***********************************************************
//------------------------ PaveDroit() -------------------------------
class PaveDroit extends Pave {
    PaveDroit() {
        super(new Forme[] { new DroitOuestEst(0, 1) },
              new Forme[] { new DroitNordOuestSudEst(0) });
        type             = 1;
        deformable       = true;
        appareil_de_voie = false;
        ordre            = 1;
    }
    Pave copy() { return new PaveDroit(); }
}
//---------------------------- PaveButoir() ---------------------------------
class PaveButoir extends Pave {
    PaveButoir() {
        super(new Forme[] { new Butoir() },
              new Forme[] { new Butoir45() } );
        type             = 2;
        deformable       = false;
        appareil_de_voie = false;
        ordre            = 1;
    }
    Pave copy() { return new PaveButoir(); }
}
//---------------------------- PaveArc45() ---------------------------------
class PaveArc45 extends Pave {
    PaveArc45() {   
        super(new Forme[] { new Arc45OuestNordEst(0) },
              new Forme[] { new Arc45NordOuestEst(0) });
        type             = 3;
        deformable       = false;
        appareil_de_voie = false;
        ordre            = 1;
    }
    Pave copy() { return new PaveArc45(); }
}
//---------------------------- PaveArc90() ---------------------------------
class PaveArc90 extends Pave {
    PaveArc90() {   
        super(new Forme[] { new Arc90() },
              new Forme[] { new Arc90NordOuestSudOuest() });
        type             = 4;
        deformable       = true;
        appareil_de_voie = false;
        ordre            = 1;
    }
    Pave copy() { return new PaveArc90(); }
}
//----------------------------- PaveCroisement45() ------------------------------
class PaveCroisement45 extends Pave {
    PaveCroisement45() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new DroitNordOuestSudEst(0) },
              new Forme[] { new DroitNordOuestSudEst(0), new DroitOuestEst(0, 2) });
        type             = 13;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 1;
        appareil_de_voie = true;
        ordre            = 2;
    }
    Pave copy() { return new PaveCroisement45(); }
}
//----------------------------- PaveCroisement90() ------------------------------
class PaveCroisement90 extends Pave {
    PaveCroisement90() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new DroitOuestEst(1, 2)  },
              new Forme[] { new DroitNordOuestSudEst(0), new DroitNordOuestSudEst(0) });
        type             = 14;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 1;
        appareil_de_voie = true;
        ordre            = 2;
    }
    Pave copy() { return new PaveCroisement90(); }
}
//----------------------------- PaveAiguilleDroite() ------------------------------
class PaveAiguilleDroite extends Pave {
    PaveAiguilleDroite() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new Arc45NordOuestEst(0)  },
              new Forme[] { new DroitNordOuestSudEst(0), new Arc45OuestNordEst(0)  });
        type             = 15;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 1;
        appareil_de_voie = true;
        ordre            = 2;
    }
    Pave copy() { return new PaveAiguilleDroite(); }
}
//----------------------------- PaveAiguilleGauche() ------------------------------
class PaveAiguilleGauche extends Pave {
    PaveAiguilleGauche() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new Arc45OuestNordEst(0) },
              new Forme[] { new DroitNordOuestSudEst(0), new Arc45NordOuestEst(0) });
        type             = 16;
        deformable       = false;
        elongation       = 2;
        appareil_de_voie = true;
        ordre            = 2;
    }
    Pave copy() { return new PaveAiguilleGauche(); }
}
//----------------------------- PaveTJS() ------------------------------
class PaveTJS extends Pave {
    PaveTJS() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new Arc45NordOuestEst(0), new DroitNordOuestSudEst(0) },
              new Forme[] { new DroitNordOuestSudEst(0), new Arc45OuestNordEst(0), new DroitOuestEst(0, 2) });
        type             = 17;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 1;
        decalage[2]      = 1;
        appareil_de_voie = true;
        ordre            = 3;
    }
    Pave copy() { return new PaveTJS(); }
}
//----------------------------- PaveTJD() ------------------------------
class PaveTJD extends Pave {
    PaveTJD() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new Arc45NordOuestEst(0), new DroitNordOuestSudEst(0), new Arc45NordOuestEst(3) },
              new Forme[] { new DroitNordOuestSudEst(0), new Arc45OuestNordEst(0), new DroitOuestEst(0, 2), new Arc45OuestNordEst(0) });
        type             = 18;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 1;
        decalage[2]      = 1;
        decalage[3]      = 3;
        appareil_de_voie = true;
        ordre            = 4;
    }
    Pave copy() { return new PaveTJD(); }
}
//----------------------------- PaveTriple() ------------------------------
class PaveTriple extends Pave {
    PaveTriple() {   
        super(new Forme[] { new DroitOuestEst(0, 2), new Arc45OuestNordEst(0), new Arc45NordOuestEst(3) },
              new Forme[] { new DroitNordOuestSudEst(0), new Arc45NordOuestEst(0), new Arc45OuestNordEst(0) });
        type             = 19;
        deformable       = false;
        elongation       = 2;
        decalage[2]      = 3;
        appareil_de_voie = true;
        ordre            = 3;
    }
    Pave copy() { return new PaveTriple(); }
}
//----------------------------- PaveSymetrique() ------------------------------
class PaveSymetrique extends Pave {
    PaveSymetrique() {   
        super(new Forme[] { new Arc45OuestNordEst(0), new Arc45NordOuestEst(3) },
              new Forme[] { new Arc45NordOuestEst(0), new Arc45OuestNordEst(0) });
        type             = 20;
        deformable       = false;
        elongation       = 2;
        decalage[1]      = 3;
        appareil_de_voie = true;
        ordre            = 2;
    }
    Pave copy() { return new PaveSymetrique(); }
}
//----------------------------- PaveFlexibleSgauche() ------------------------------
class PaveFlexibleSgauche extends Pave {
    PaveFlexibleSgauche() {   
        super(new Forme[] { new FlexibleSgauche() },
              new Forme[] { new FlexibleSgauche45() });
        type             = 5;
        deformable       = true;
        appareil_de_voie = false;
        ordre            = 1;
    }
    //-------------------------- dessine_pave_debut() -----------------------------
    void dessine_pave_debut(int _c, int _l) {
        couleurs_pave();
        int forme_length = Formes.length;
        if (orientation % 2 == 0) {
            for (int i = 0; i < forme_length; i++) {
                hauteur_voie  = int(max(1, abs(hauteur_voie)));
                longueur_voie = max(int(max(1, abs(longueur_voie))), hauteur_voie+1);
                deformation   = int(MAILLE/2+((deformation-1) % 40*MAILLE*(hauteur_voie))/40);
                Formes45[0].modification_flexible(orientation, longueur_voie, hauteur_voie, deformation, appareil_de_voie,
                                                  butoir[0], butoir[1], cible[0], cible[1], cible_visible[0], cible_visible[1]);                   //  on fait toutes les modifications de formes
                Formes45[0].connecteurs_absolus(_c, _l);                                                                                           //  calcule les coordonnees absolues des connecteurs
                connecteur[0][0].x       = Formes45[0].connecteur_absolu0.x;                                                                       //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][0].y       = Formes45[0].connecteur_absolu0.y;
                connecteur[1][0].x       = Formes45[0].connecteur_absolu1.x;                                                                       //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][0].y       = Formes45[0].connecteur_absolu1.y;
                Formes45[0].retrait0     = connecteur[0][0].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes45[0].retrait1     = connecteur[1][0].z;
                base0[0]                 = Formes45[0].base[0];
                base1[0]                 = Formes45[0].base[1];
                base12[0]                = Formes45[0].base[12];
                base13[0]                = Formes45[0].base[13];
                Formes45[0].dessine_cibles(0);                                                                                                     //  dessine toutes les cibles une seule fois
                Formes45[0].dessine_cibles(1);                                                                                                     //  dessine toutes les cibles une seule fois
            }
        } else {
            for (int i = 0; i < forme_length; i++) {
                hauteur_voie  = int(-max(1, abs(hauteur_voie)));
                longueur_voie = max(int(max(1, abs(longueur_voie))), abs(hauteur_voie));
                deformation   = int(MAILLE + (elongation % 40*MAILLE*(longueur_voie + hauteur_voie))/40);
                Formes[0].modification_flexible(orientation, longueur_voie, hauteur_voie, deformation, appareil_de_voie,
                                                butoir[0], butoir[1], cible[0], cible[1], cible_visible[0], cible_visible[1]);                     //  on fait toutes les modifications de formes
                Formes[0].connecteurs_absolus(_c, _l);                                                                                             //  calcule les coordonnees absolues des connecteurs
                connecteur[0][0].x       = Formes[0].connecteur_absolu0.x;                                                                         //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][0].y       = Formes[0].connecteur_absolu0.y;
                connecteur[1][0].x       = Formes[0].connecteur_absolu1.x;                                                                         //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][0].y       = Formes[0].connecteur_absolu1.y;
                Formes[0].retrait0       = connecteur[0][0].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes[0].retrait1       = connecteur[1][0].z;
                base0[0]                 = Formes[0].base[0];
                base1[0]                 = Formes[0].base[1];
                base12[0]                = Formes[0].base[12];
                base13[0]                = Formes[0].base[13];
                Formes[0].dessine_cibles(0);                                                                                                       //  dessine toutes les cibles une seule fois
                Formes[0].dessine_cibles(1);                                                                                                       //  dessine toutes les cibles une seule fois
            }
        }
    }
    Pave copy() { return new PaveFlexibleSgauche(); }
}
//----------------------------- PaveFlexibleSdroit() ------------------------------
class PaveFlexibleSdroit extends Pave {
    PaveFlexibleSdroit() {   
        super(new Forme[] { new FlexibleSdroit() },
              new Forme[] { new FlexibleSdroit45() });
        type             = 6;
        deformable       = true;
        appareil_de_voie = false;
        ordre            = 1;
    }
    //-------------------------- dessine_pave_debut() -----------------------------
    void dessine_pave_debut(int _c, int _l) {
        couleurs_pave();
        int forme_length = Formes.length;
        if (orientation % 2 == 0) {
            for (int i = 0; i < forme_length; i++) {
                longueur_voie = int(max(1, abs(longueur_voie-1)));
                hauteur_voie  = max(int(max(1, abs(hauteur_voie))), longueur_voie+1);
                deformation   = int(MAILLE/2+((deformation-1) % 40*MAILLE*(hauteur_voie))/40);
                Formes45[0].modification_flexible(orientation, longueur_voie, hauteur_voie, deformation,
                                                  appareil_de_voie, butoir[0], butoir[1], cible[0], cible[1], cible_visible[0], cible_visible[1]); //  on fait toutes les modifications de formes
                Formes45[0].connecteurs_absolus(_c, _l);                                                                                           //  calcule les coordonnees absolues des connecteurs
                connecteur[0][0].x       = Formes45[0].connecteur_absolu0.x;                                                                       //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][0].y       = Formes45[0].connecteur_absolu0.y;
                connecteur[1][0].x       = Formes45[0].connecteur_absolu1.x;                                                                       //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][0].y       = Formes45[0].connecteur_absolu1.y;
                Formes45[0].retrait0     = connecteur[0][0].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes45[0].retrait1     = connecteur[1][0].z;
                base0[0]                 = Formes45[0].base[0];
                base1[0]                 = Formes45[0].base[1];
                base12[0]                = Formes45[0].base[12];
                base13[0]                = Formes45[0].base[13];
                Formes45[0].dessine_cibles(0);                                                                                                     //  dessine toutes les cibles une seule fois
                Formes45[0].dessine_cibles(1);                                                                                                     //  dessine toutes les cibles une seule fois
            }
        } else {
            for (int i = 0; i < forme_length; i++) {
                hauteur_voie  = int(max(1, abs(hauteur_voie)));
                longueur_voie = max(int(max(1, abs(longueur_voie))), abs(hauteur_voie));
                deformation   = -int((elongation % 40*MAILLE*(longueur_voie))/40);
                Formes[0].modification_flexible(orientation, longueur_voie, hauteur_voie, deformation,
                                                appareil_de_voie, butoir[0], butoir[1], cible[0], cible[1], cible_visible[0], cible_visible[1]);   //  on fait toutes les modifications de formes
                Formes[0].connecteurs_absolus(_c, _l);                                                                                             //  calcule les coordonnees absolues des connecteurs
                connecteur[0][0].x       = Formes[0].connecteur_absolu0.x;                                                                         //  connecteur[0][] à gauche du pave, connecteur0 à gauche sur la forme
                connecteur[0][0].y       = Formes[0].connecteur_absolu0.y;
                connecteur[1][0].x       = Formes[0].connecteur_absolu1.x;                                                                         //  connecteur[1][] à droite du pave, connecteur1 à droite sur la forme
                connecteur[1][0].y       = Formes[0].connecteur_absolu1.y;
                Formes[0].retrait0       = connecteur[0][0].z;                                                                                     //  z <= 0 => retrait non visible, z = 1 => retrait visible
                Formes[0].retrait1       = connecteur[1][0].z;
                base0[0]                 = Formes[0].base[0];
                base1[0]                 = Formes[0].base[1];
                base12[0]                = Formes[0].base[12];
                base13[0]                = Formes[0].base[13];
                Formes[0].dessine_cibles(0);                                                                                                       //  dessine toutes les cibles une seule fois
                Formes[0].dessine_cibles(1);                                                                                                       //  dessine toutes les cibles une seule fois
            }
        }
    }
    Pave copy() { return new PaveFlexibleSdroit(); }
}
//----------------------------- PavePont() ------------------------------
class PavePont extends Pave {
    int compte_pont;
    PavePont() {   
        super(new Forme[] { new Fosse(10), new Pont(), new RailsPont() },
              new Forme[] { new Fosse(10), new Pont(), new RailsPont() });
        type             = 12;
        deformable       = true;
        appareil_de_voie = false;
    }
    //--------------------------- dessine_pave_palette() ------------------------
    void dessine_pave_palette() {
        Formes[0].dessine_forme_fosse(2*MAILLE);                                                                                                   // dessine la fosse de la couleur FOSSE
        Formes[1].dessine_forme_pont_palette(PONT, 0, 0);                                                                                          // dessine le pont tournant de la couleur PONT
        Formes[2].dessine_forme(couleur_rail, RAIL);                                                                                               // dessine les rails du pont tournant de la couleur des rails (depend du niveau)
    }
    //--------------------------- dessine_pave() --------------------------------
    void dessine_pave(int _c, int _l) {
        couleurs_pave();
        Formes[0].dessine_forme_fosse((elongation+1)*MAILLE);                                                                                      // dessine la fosse de la couleur FOSSE
        Formes[1].modification_pont((elongation+1)*MAILLE);
        Formes[1].dessine_forme_pont(PONT);                                                                                                        // dessine le pont tournant de la couleur PONT
        Formes[2].modification_pont(elongation+1);
        Formes[2].dessine_forme(couleur_rail, RAIL);                                                                                               // dessine les rails du pont tournant de la couleur des rails (depend du niveau)
        Formes[2].connecteurs_absolus(_c, _l);                                                                                                     //  calcule les coordonnees absolues des connecteurs
        connecteur[0][0]           = Formes[2].connecteur_absolu0;
        connecteur[1][0]           = Formes[2].connecteur_absolu1;
        Formes[2].dessine_points();
    }
    Pave copy() { return new PavePont(); }
}
//----------------------------- PaveVoiePont() ------------------------------
class PaveVoiePont extends Pave {
    PaveVoiePont() {   
        super(new Forme[] { new VoiePont() },
              new Forme[] { new VoiePont() });
        type             = 11;
        deformable       = true;
        appareil_de_voie = false;
    }
    void dessine_pave_palette() {
        Formes[0].dessine_forme(couleur_rail, RAIL);
    }
    void dessine_pave(int _c, int _l) {
        couleurs_pave();
        deformation = elongation;
        Formes[0].modification_voie_pont(_c, _l, longueur_voie, hauteur_voie, deformation, ordre);
        Formes[0].dessine_forme(couleur_rail, RAIL);
        Formes[0].connecteurs_absolus(_c, _l);                                                                                                     //  calcule les coordonnees absolues des connecteurs
        connecteur[0][0]         = Formes[0].connecteur_absolu0;
        connecteur[1][0]         = Formes[0].connecteur_absolu1;
        Formes[0].dessine_points();
    }
    Pave copy() { return new PaveVoiePont(); }
}
//-------------------------- NullPave() -----------------------------
class NullPave extends Pave {
    int type = 0;
    NullPave() {
        super(new Forme[] { new NullForme() },
              new Forme[] { new NullForme() });
        type        = 0;
        deformable  = false;
    }
}
