//********************************************************** Train (# Pave) ***********************************************************************************
class Train {
    int        nb_vehicules                 = 0;                                                                                           //  nombre de vehiculmes du train
    int        consigne                     = 0;                                                                                           //  consigne de vitesse donnee par le curseur
    int        numero_train                 = 0;                                                                                           //  numero du train (numero_train = numero du pupitre+1)
    int        numero_pupitre               = 0;
    float      vitesse                      = 0;                                                                                           //  vitesse du train
    int        ancienne_vitesse             = 0;
    int        ancienne_position            = 0;
    int        nouvelle_vitesse             = 0;
    int        nouvelle_position            = 0;
    int        debut_train                  = 0;
    int        longueur_train               = 0;
    PVector    coord_debut_train            = new PVector(0, 0, 0);
    PVector    coord_fin_train              = new PVector(0, 0, 0);
    int        position_attelage            = 0;
    PVector    coord_attelage               = new PVector();
    //----------------------------- signaux --------------------------------------
    int        code_signal_zone             = -1;
    int        code_signal_zone_ancien      = -1;
    int        position_signal              = 0;                                                                                           //  position du signal, c'est à dire le nombre de points depuis le depart de l'itinéraire
    int        position_signal_zone         = 0;
    int        position_signal_suivant      = 0;
    int        cote_feu                     = 0;
    int        cote_signal_zone             = 0;
    int        position_proche              = 0;
    //----------------------------- ralentissements ------------------------------                                                         //  on prepare l'arret, le ralentissement
    boolean    ralentissement30             = false;                                                                                       //  une zone occupee par un train ou la vitesse deviee est limitee à 30 km/h
    boolean    ralentissement60             = false;                                                                                       //  une zone occupee par un train ou la vitesse deviee est limitee à 60 km/h
    int        zone_freinage                = 0;                                                                                           //  zone_freinage est le radar à l'entrée de la zone    
    int        vitesse_initiale             = 0;                                                                                           //  vitesse initiale en entrée de zone d'arret ou de ralentissement
    int        depart                       = 0;                                                                                           //  variable intermediaire permettant le calcul du prochain point de ralentissement
    int        distance_securite            = 0;
    //----------------------------- transferts -----------------------------------
    int        position_double              = 0;                                                                                           //  position du train dans le futur itinéraire lors du transfert
    boolean    transfert                    = false;                                                                                       //  transfert d'un train d'un itinéraire à l'autre
    long       nouvel_arret_en_gare         = 0;
    long       ancien_arret_en_gare         = 0;
    boolean    arret_en_gare                = false;
    boolean    arret_lance                  = false;
    boolean    efface_iti_tempo             = false;
    boolean    libre                        = true;

    Pave       paveSignalZone;
    Pave       paveSignalZoneAncien;
    Zone       zone_occupee_debut;
    Pave       pave_feu;
    Itineraire iti_train;
    Itineraire iti_double;
    Itineraire iti_deja_fait;
    Itineraire iti_recopie;
    Itineraire iti_deuxieme;

    ArrayList<Zone>      zones_occupees     = new ArrayList<Zone>();                                                                       //  liste de toutes les zones occupées
    ArrayList<Vehicule>  compo_train        = new ArrayList<Vehicule>();                                                                   //  liste de tous les véhicules
    ArrayList<Vehicule>  compo_train_bis    = new ArrayList<Vehicule>();                                                                   //  liste de tous les véhicules_bis
    ArrayList<Vehicule>  compo_train_ter    = new ArrayList<Vehicule>();                                                                   //  liste de tous les véhicules_bis
    
    
    Train() {}

    //--------------------------------- gere_train() ----------------------------------------------------
    void gere_train() {
        nb_vehicules = compo_train.size();
        //*********************************************************************************************************************************
        //---------------------------- positionnement du train au depart ----------------------
        if (debut_train < 1) {                                                                                                             //  on ne peut avoir de train que sur un itinéraire valide. A ce stade, il n'a pas encore de position
            boolean moteur = false;
            for (Vehicule veh0 : compo_train) {
                if (veh0.moteur) {
                    moteur = true;
                    break;
                }
            }
            //------------------ calcul des points de l'itinéraire ----------                                                              //  il n'y a qu'un seul calcul des points puisqu'on ne pose un train qu'une fois par train
            for (Pave pave0 : iti_train.paves_composant_iti) {
                if (pave0.numero_train1 == 0) {                                                                                            //  on ne peut mettre un train que sur une zone reservée, mais sans train
                    pave0.numero_train1  = abs(numero_train);                                                                              //  on lui affecte un numéro ( > 0)
                } else {
                    break;
                }
            }
            numero_train   = iti_train.numero_train;
            train_pupitre(iti_train.numero_train);
            numero_pupitre = num_train_pupitre;
            prolonge_numero_train(iti_train);
            for (Pave pave0 : iti_train.paves_composant_iti) {
                if (abs(pave0.numero_train1) == abs(numero_train)) {
                    pave0.affiche_iti_tempo = false;
                } else {
                    break;
                }
            }
            pupitre.horloge[numero_pupitre] = true;
            cursor(curseur_horloge, 25,25);            
            texte_affiche    = "Le pointeur 'horloge' permet de choisir la durée d'arrêt en déplaçant le curseur. Clic DROIT pour valider la durée d'arrêt en gare";
            couleur_affichee = SABLE;                      
            //-------- pose du train ---
            int nb_points_iti = iti_train.points_composant_iti.size();
            for (int pos = 0; pos < nb_points_iti; pos++) {
                if (pos == iti_train.position_signaux_iti.get(0)) {                                                                        //  on recherche la position du premier signal de l'itinéraire
                    debut_train              = pos-int(10/PAS);                                                                            //  le train est pose 100 points avant la position du premier signal
                    iti_train.iti_change     = true;
                    iti_train.iti_affiche    = true;
                    break;
                }
            }
        }
        //*********************************************************************************************************************************
        //------------------------------------------------------- transfert du train au debut de l'itinéraire --------------------------------------------------------------------------------
        if (!transfert && zones_occupees.contains(iti_train.zone_fin)                                                                      //  le transfert n'est pas en cours et le train est (au moins) sur la zone de fin de l'itinéraire
            && (iti_train.duree_arret == 0 || (iti_train.duree_arret > 0 && iti_train.pave_fin.carre_manuel[1-iti_train.pave_fin.entree_pave] == 0))) {
            Itineraire iti_suivant = iti_train.iti_suivant;                                                                                //  simplification d'ecriture
            if (iti_suivant != null) {                                                                                                     //  l'itinéraire suivant ne doit pas être nul
                iti_suivant.pave_debut = iti_suivant.paves_composant_iti.get(0);                                                           //  mise à jour du pavé début d'iti_suivant
                for (Zone zone1 : toutes_zones) {                                                                                          //  recherche de la zone début d'iti_suivant
                    if (zone1.paves_composant_zone.contains(iti_suivant.pave_debut)) {
                        iti_suivant.zone_debut = zone1;                                                                                    //  on a trouvé la zone début d'iti_suivant
                        break;
                    }
                }
                boolean pave_occupe = false;                                                                                               //  teste l'INEXISTENCE, dans l'itinéraire suivant, d'un pavé occupé par le même train
                for (Pave pave0 : iti_suivant.paves_composant_iti) {
                    if (pave0.occupe 
                    && (abs(pave0.numero_train1) == abs(iti_suivant.numero_train) 
                     || abs(pave0.numero_train2) == abs(iti_suivant.numero_train))) {
                        if (!iti_suivant.zone_debut.paves_composant_zone.contains(pave0)) {
                            if (iti_train.pave_fin != iti_suivant.pave_debut) {                                                            //  si la fin de l'itinéraire n'est pas le début de l'itinéraire suivant
                                if (iti_train.pave_debut != iti_suivant.pave_debut) {                                                      //  si les deux itinéraires ont un début commun, ça ne compte pas
                                    pave_occupe = true;
                                }
                            }
                        }
                    }
                }
                if (zones_occupees.contains(iti_suivant.zone_debut) && (!pave_occupe || iti_train.iti_sur_place)) {                        //  on ne se pose la question du transfert que si le train a atteint la zone début de l'itinéraire suivant
                                                                                                                                           //       et qu'il n'y a pas, dans l'itinéraire suivant, de pavé occupé par le même train
                    if ((iti_train.pave_fin != iti_suivant.pave_debut)                                                                     //  si la zone commune est sur plusieurs pavés, il faut que que
                                                                                                                                           //       le pavé fin d'iti_train soit différent du pavé début d'iti_suivant
                    || (iti_train.pave_fin == iti_suivant.pave_debut                                                                       //  si la zone commune n'est que sur un pavé il faut que 
                        && iti_train.entree_pave[iti_train.paves_composant_iti.size()-1] == iti_suivant.entree_pave[0])) {                 //       les entrées pavé fin d'iti_train et pave début d'iti_suivant soient identiques
                        //------------------------------------ les deux itinéraires sont dans le même sens ----------------------------------------
                        if (iti_deja_fait != iti_suivant) {                                                                                //  pour ne faire le calcul qu'une seule fois
                            int compteur_paves_suivant = -1;                                                                               //  compteur de pavés d'iti_suivant
                            //------------------------ ajout des zones occupées de l'itinéraire courant -------------------
                            for (Pave pave0 : iti_train.paves_composant_iti) {
                                if (pave0 == iti_suivant.pave_debut) {
                                    break;                                                                                                 //  on sort quand on a atteint le premier pavé de l'iti_suivant
                                } else {
                                    if (!iti_suivant.paves_composant_iti.contains(pave0) 
                                    && (abs(pave0.numero_train1) == numero_train || abs(pave0.numero_train2) == numero_train)) {           //  on ne démarre qu'au premier pavé d'iti_train qui n'est pas dans iti_suivant
                                        compteur_paves_suivant++;                                                                          //  on avance en iti_suivant
                                        iti_suivant.paves_composant_iti.add(compteur_paves_suivant, pave0);                                //  l'itinéraire suivant augmente d'un pavé pris dans iti_train
                                        for (int i = INDEX_MAX-1; i > compteur_paves_suivant; i--) {                                       //  cela décale les lames et les entree_pave d'iti_suivant
                                            iti_suivant.lames[i]       = iti_suivant.lames[i-1];
                                            iti_suivant.entree_pave[i] = iti_suivant.entree_pave[i-1];
                                        }
                                        iti_suivant.lames[compteur_paves_suivant]       = pave0.lames;                                     //  dans la place libérée, on met lames et entre_pave du nouveau pavé
                                        iti_suivant.entree_pave[compteur_paves_suivant] = pave0.entree_pave;
                                    }
                                }
                            }
                            //-------------------------- traitement de l'itinéraire suivant -------------------------------
                            prolonge_numero_train(iti_suivant);
                            iti_deja_fait = iti_suivant;                                                                                   //  pour ne calculer les points qu'une seule fois
                        }
                        //---------------------------- calcul du transfert ------------------------------------------------
                        for (int pos = 0; pos < iti_suivant.points_composant_iti.size(); pos++) {
                            if (PVector.dist(iti_suivant.points_composant_iti.get(pos).coord, coord_debut_train) < 0.1) {                  //  on recherche la position future du train sur le nouvel itinéraire, elle correspond à debut_train
                                position_double = pos;
                                iti_double      = iti_suivant;                                                                             //  iti_double est mémorisé pour le transfert effectif
                                transfert       = true;                                                                                    //  on permet le transfert
                                break;
                            }
                        }                        
                    } else {
                        //------------------------------------ les deux itinéraires sont dans des sens opposés -----------------------------------
                        if (vitesse == 0) {                                                                                                //  on ne peut inverser le sens qu'à vitesse nulle
                            if (iti_deja_fait != iti_suivant) {
                                //-------------------------- traitement de l'itinéraire suivant -------------------------------
                                prolonge_numero_train(iti_suivant);
                                iti_deja_fait = iti_suivant;                                                                               //  pour ne calculer les points qu'une seule fois
                            }
                            //----------------------------- calcul du transfert ---------------------------------------------------
                            for (int pos = 0; pos < iti_suivant.points_composant_iti.size(); pos++) {
                                if (PVector.dist(iti_suivant.points_composant_iti.get(pos).coord, coord_fin_train) < 0.1) {                //  on recherche la position future du train sur le nouvel itinéraire //<>//
                                    position_double = pos;
                                    iti_double      = iti_suivant;                                                                         //  iti_double est mémorisé pour le transfert effectif
                                    transfert       = true;                                                                                //  on permet le transfert
                                    retourne_train();
                                    break;
                                }
                            }
                            if (!transfert) {
                                texte_affiche    = "La route actuelle et la suivante sont incompatibles. Effacez le cycle et recommencez";
                                couleur_affichee = POURPRE;
                                hauteur_curseur[numero_pupitre] = 0;
                            }
                        }
                    }
                }
            }
        }
        debut_train  = min(int(debut_train), iti_train.points_composant_iti.size()-1);                                                     //  le train ne peut pas depasser la fin de l'itinéraire
        positions_vehicules();
        gere_occupations_vitesse();
        //---------------------------------------------- trouver signal de la zone, dans le bon sens --------------------------------------
        pave_feu = iti_train.points_composant_iti.get(debut_train).pave;                                                                   //  on recupere tout d'abord le pavé sur lequel est le vehicule[0]
        pave_feu = pave_feu.pave_signal_zone[1-pave_feu.entree_pave];                                                                      //  on calcule alors le pavé du signal de zone dans le bon sens
    }
    //---------------------------------------------- positions_vehicules() ---------------------------------------------------------------------
    void positions_vehicules() {
        nb_vehicules = compo_train.size();
        compo_train.get(0).iti_train    = iti_train;                                                                                       //  chaque véhicule appartient à un itinéraire
        compo_train.get(0).numero_train = abs(numero_train);                                                                               //  chaque véhicule a le numéro du train (puisqu'il y a un véhicule, le numéro de train est forcément > 0)
        compo_train.get(0).position  = debut_train;                                                                                        //  en tire, le début_train est le véhicule 0
        compo_train.get(0).iti_train = iti_train;                                                                                          //  chaque véhicule appartient à un itinéraire
        for (int vh = 1; vh < nb_vehicules; vh++) {                                                                                        //  on va dans le sens croissant, puisqu'on part du véhicule 0
            if (compo_train.get(vh-1).moteur) {                                                                                            //  --- si le véhicule précédent est moteur
                if (compo_train.get(vh).moteur) {                                                                                          //  ----- si le véhicule courant est moteur
                    compo_train.get(vh).position  = int(compo_train.get(vh-1).position-compo_train.get(vh-1).nb_points_veh);               //  il n'y a pas d'écart
                } else {                                                                                                                   //  ----- si le véhicule courant n'est pas moteur
                    compo_train.get(vh).position = compo_train.get(vh-1).position-compo_train.get(vh-1).nb_points_veh-ECART;               //  il y a un seul écart
                }
            } else {                                                                                                                       //  --- si le véhicule précédent n'est pas moteur
                if (compo_train.get(vh).moteur) {                                                                                          //  ----- si le véhicule courant est moteur
                    compo_train.get(vh).position = compo_train.get(vh-1).position-compo_train.get(vh-1).nb_points_veh-ECART;               //  il y a un seul écart
                } else {                                                                                                                   //  ----- si le véhicule courant n'est pas moteur
                    compo_train.get(vh).position = compo_train.get(vh-1).position-compo_train.get(vh-1).nb_points_veh-2*ECART;             //  il y a 2 écarts (un par véhicule)                                                                                  
                }
            }
            compo_train.get(vh).position = max(0, compo_train.get(vh).position);                                                           //  on ne peut pas avoir de position négative
            compo_train.get(vh).iti_train = iti_train;                                                                                     //  chaque véhicule appartient à un itinéraire
        }
        coord_debut_train = iti_train.points_composant_iti.get(debut_train).coord;
        longueur_train    = 0;                                                                                                             //  initialisation de la longueur du train
        for (int vh = 0; vh < nb_vehicules; vh++) {
            longueur_train = longueur_train+compo_train.get(vh).nb_points_veh;                                                             //  on ajoute toutes les longueurs de véhicules
            if (!compo_train.get(vh).moteur) {
                longueur_train = longueur_train+2*ECART;                                                                                   //  on ajoute 2 écarts par véhicule non moteur
            }
        }
        coord_fin_train   = iti_train.points_composant_iti.get(max(0, debut_train-longueur_train)).coord;
    }    
    //---------------------------------------------- dessine le train ---------------------------------------------------------
    void dessine_train(int _numero_train) {
        boolean premier = true;
        for (int vh = 0; vh < nb_vehicules; vh++) {
            compo_train.get(vh).numero_train = _numero_train;
            compo_train.get(vh).dessine_vehicule();
        }
        for (int vh = nb_vehicules-1; vh > -1; vh--) {
            compo_train.get(vh).dessine_aiguille();
        }
    }  
    //****************************************************************** gere_occupations_vitesse() ******************************************************************************************************
    void gere_occupations_vitesse() {
        //---------------------- detection de la presence des trains sur les zones de ralentissement devie --------------
        ralentissement30 = false;
        ralentissement60 = false;
        for (Zone zone1 : zones_occupees) {                                                                                                //  on regarde pour toute la zone occupée
            for (Pave pave0 : zone1.paves_composant_zone) {                                                                                //  puis dans chaque pavé de la zone occupée
                if (pave0.vitesse_deviee == 60 && !ralentissement30) {                                                                     //  si la vitesse dévié est à 60, on met un ralentissement à 60, sauf si le ralentissement 30 est déjà fait
                    ralentissement60 = true;
                } else {
                    if (pave0.vitesse_deviee == 30){                                                                                       //  si on a un ralentissement 30, on peut sortir et effacer le ralentissement 60
                        ralentissement60 = false;
                        ralentissement30 = true;
                        break;
                    }
                }                
            }
        }
        //--------------------- relance d'un train arrêté ------------------------                                                         //  on ne relance le train que s'il peut aller jusqu'à un autre signal via des pavés réservés (< 0)
        if (iti_train.iti_en_attente && iti_train.numero_train > 0 && premier_pave == null) {
            prolonge_numero_train(iti_train);
            Pave pave_vehicule   = iti_train.points_composant_iti.get(debut_train).pave;                                                   //  pave_vehicule est le pavé sur lequel est le véhicule
            int cote_pave        = 1-pave_vehicule.entree_pave;                                                                            //  cote par lequel le train va sortir du le pavé (inverse de l'entrée)
            paveSignalZone       = pave_vehicule.pave_signal_zone[cote_pave];                                                              //  paveSignalZone est le pavé où est le signal de la zone, dans le sens de l'itinéraire
            int cote_signal_zone = pave_vehicule.cote_signal_zone[cote_pave];                                                              //  cote du signal de la zone, vu du pavé du signal, dans le sens de l'itinéraire
            code_signal_zone     = paveSignalZone.code_signal[cote_signal_zone];                                                           //  code du signal de zone, du bon cote
            if (code_signal_zone != SEMAPHORE && code_signal_zone != CARRE && code_signal_zone != CARRE_VIOLET) {
                prolonge_numero_train(iti_train);
                for (Pave pave0 : iti_train.paves_composant_iti) {                                                                         //  on efface tous les feux noirs de l'itinéraire
                    pave0.feu_noir[0]       = false;
                    pave0.feu_clignotant[0] = false;
                    pave0.feu_noir[1]       = false;
                    pave0.feu_clignotant[1] = false;
                }
                if (vitesse == 0) {
                    nouvelle_position = debut_train+2;
                }
            }
        }
        //------------------------------------------------- enregistrement des véhicules ----------------------------------------------------
        zones_occupees.clear();                                                                                                            //  on efface la liste des zones occupées de l'itinéraire
        iti_train.zones_composant_iti.clear();
        Pave pave_debut_train = iti_train.points_composant_iti.get(debut_train).pave;                                                      //  c'est le pavé de la position du début de train, en tire ou en pousse
        Pave pave_fin_train   = iti_train.points_composant_iti.get(max(0, debut_train-longueur_train)).pave;                               //  c'est la pavé de la position de l'arrière du train, en tire ou en pousse
        //--------------- ajoute les véhicules ---------------------------
        for (Pave pave0 : iti_train.paves_composant_iti) {
            pave0.recopie = false;
            if (!iti_train.zones_composant_iti.contains(pave0.zone_pave)) {                                                                //  si les zones composant iti_train ne contiennent pas la zone correspondant au pavé en cours...
                iti_train.zones_composant_iti.add(pave0.zone_pave);                                                                        //  ...on ajoute cette zone
            }                                                                                                                              //  à ce stade, on a remis à jour la liste des zones composant iti_train
        }                                                                                      
        boolean pave_fin_train_trouve = false;
        for (Pave pave0 : iti_train.paves_composant_iti) {
            if (pave0 == pave_fin_train || pave_fin_train_trouve) {                                                                        //  soit on a atteint le pave_fin_train, soit on l'a dépassé
                pave_fin_train_trouve = true;                                                                                              //  on mémorise le fait qu'on a trouvé la fin du train
                if (!zones_occupees.contains(pave0.zone_pave)) {                                                                           //  on ne mémorise dans zones_occupees qu'une fois chaque zone
                    zones_occupees.add(pave0.zone_pave);
                    pave0.zone_pave.occupee = true;
                }
            }
            if (pave0 == pave_debut_train) {                                                                                               //  on sort si on arrive au pave_debut_train
                if (!zones_occupees.contains(pave0.zone_pave)) {                                                                           //  on ne mémorise dans zones_occupees qu'une fois chaque zone
                    zones_occupees.add(pave0.zone_pave);
                }
                break;
            }
        }
        zone_occupee_debut   = zones_occupees.get(0);                                                                                      //  la zone occupée début est la première zone
        iti_train.zone_debut = zones_occupees.get(0);                                                                                      //  mise à jour de la zone_debur d'iti_train
        //------------------------- mise à jour des occupations de zones et de paves ---------------------------------
        for (Zone zone1 : zones_occupees) {
            for (Pave pave0 : zone1.paves_composant_zone) {
                pave0.recopie = true;
            }
        }
        for (Zone zone1 : iti_train.zones_composant_iti) {
            if (zone1.occupee) {
                for (Pave pave0 : zone1.paves_composant_zone) {
                    pave0.occupe = true;
                }
            } else {
                for (Pave pave0 : zone1.paves_composant_zone) {
                    pave0.occupe = false;
                }
            }
        }
        iti_train.dessine_itineraire();
        //------------------ création iti_recopie --------------------------------------------------------------------
        Pave pave_courant   = iti_train.paves_composant_iti.get(0);                                                                        //  quand on efface, on décide que c'est le premier pavé
        for (Pave pave0 : iti_train.paves_composant_iti) {                                                                                 //  puis on décale ce premier pavé si c'était un appareil de voie
            if (!pave0.appareil_de_voie) {
                pave_courant = pave0;                                                                                                      //  le pave_courant est redéfini
                break;
            }
        }
        if ((!transfert && !pave_courant.recopie) || (transfert && pave_courant.recopie)) {                                                //  2 cas : si on est en train de transférer, c'est lui qui donne le top
                                                                                                                                           //          si on n'est pas en train de transférer, c'est le pave_courant non occupé qui donne le top. Vitesse != 0
                                                                                                                                           //              la vitesse doit être non nulle (cas de l'effacement iti sur place : vitesse = 0)
            if (iti_train.cycle && !supp_en_cours) {                                                                                       //  il faut évidemment qu'il s'agisse d'un cycle
                if (pave_courant == iti_train.pave_premier) {                                                                              //  on ne s'interesse qu'au pave_premier
                    iti_recopie = new Itineraire();                                                                                        //  on crée iti_recopie
                    tous_iti.add(iti_recopie);                                                                                             //  on l'ajoute aux itinéraires
                    int compteur_paves = -1;
                    for (Pave pave0 : iti_train.paves_composant_iti) {
                        compteur_paves++;
                        iti_recopie.paves_composant_iti.add(iti_train.paves_composant_iti.get(compteur_paves));                            //  on l'initialise avec iti_train
                        iti_recopie.lames[compteur_paves]       = iti_train.lames[compteur_paves];                    
                        iti_recopie.entree_pave[compteur_paves] = iti_train.entree_pave[compteur_paves];
                    }
                    iti_recopie.numero_train                 = -abs(iti_train.numero_train);                                               //  c'est un numero_train ( < 0) car il n'y a pas encore de train sur cet itinéraire
                    iti_recopie.pave_debut                   = iti_train.pave_debut;
                    iti_recopie.pave_premier                 = iti_train.pave_premier;
                    iti_recopie.pave_fin                     = iti_train.pave_fin;                    
                    iti_recopie.zone_debut                   = iti_train.zone_debut;                    
                    iti_recopie.zone_fin                     = iti_train.zone_fin;                    
                    iti_recopie.cycle                        = true;
                    iti_recopie.iti_en_attente               = false;
                    iti_recopie.duree_arret                  = iti_train.duree_arret;
                    int taille = tous_iti.size();                                                                                          //  par construction, iti_recopie sera le suivant du dernier itinéraire du cycle
                    for (int num_iti = taille-2; num_iti > -1; num_iti--) {                                                                //  on recherche le dernier du cycle en partant du bas de la liste
                        Itineraire iti0 = tous_iti.get(num_iti);
                        if (abs(iti0.numero_train) == abs(iti_recopie.numero_train) && iti0.iti_suivant == null) {                         //  il a le même numéro de train et pas de suivant
                            iti0.iti_suivant = iti_recopie;                                                                                //  l'iti_recopie devient le suivant du dernier itinéraire avec ce numéro de train
                            break;
                        }
                    }
                }
            }
        }
        //------------------ effacement des zones et des pavés les composant --------------------------------------------------------------------
        int memo_numero1 = 0;
        for (Zone zone1 : iti_train.zones_composant_iti) {                                                                                 //  on va cherche s'il y a une zone à effacer
            zone1.effacable = false;
        }
        for (Zone zone1 : iti_train.zones_composant_iti) {                                                                                 //  on va cherche s'il y a une zone à effacer
            if (!zones_occupees.contains(zone1)) {                                                                                         //  on n'efface une zone que si elle ne fait plus partie des zones occupées
                for (Pave pave0 : zone1.paves_composant_zone) {                                                                            //  on va traiter tous les pavés composant la zone à effacer
                    if (iti_train.paves_composant_iti.contains(pave0)) {                                                                   //  
                        if (pave0.numero_train2 == 0) {                                                                                    //  cas normal, on n'a qu'un numéro de train dans le pavé
                            for (int j = 0; j < INDEX_MAX-1; j++) {                                                                        //  il faut decaler la position des lames et l'entrée dans le pave
                                iti_train.lames[j]         = iti_train.lames[j+1];                                                         //  la position des lames est decalée
                                iti_train.entree_pave[j]   = iti_train.entree_pave[j+1];                                                   //  l'entree_pavé est aussi decalée
                            }
                            pave0.numero_train1 = 0;                                                                                       //  on efface le numéro de train                                
                            pave0.occupe        = false;                                                                                   //  on efface le pave, uniquement parce qu'il n'est plus occupé
                            iti_train.paves_composant_iti.remove(pave0);                                                                   //  effacement du pavé
                            zone1.occupee       = false;                                                                                   //  la zone à effacer n'est plus occupée
                            zone1.effacable     = true;                                                                                    //  la zone devient effaçable
                        } else {                                                                                                           //  on a deux trains dans le pavé
                            memo_numero1 = pave0.numero_train1;                                                                            //  on mémorise le premier numéro de train du pavé pour traitement ultérieur
                            memo_numero2 = pave0.numero_train2;
                            pave0.numero_train1 = pave0.numero_train2;                                                                     //  on écrase le numéro de train numéro 1 avec le numéro de train 2
                            pave0.numero_train2 = 0;                                                                                       //  on met le numero_train2 à 0
                        }
                    }
                }
                iti_train.paves_composant_iti.trimToSize();                                                                                //  on remet au propre les paves_composant_iti si on est passé dans le cas normal
            } else {                                                                                                                       //  si la zone à effacer n'est pas la première zone, on sort
                break;
            }
        }
        for (Itineraire iti0 : tous_iti) {                                                                                                 //  traitement des pavés à deux trains. On balaie tous les itinéraires
            if (abs(iti0.numero_train) == memo_numero1) {                                                                                  //  on ne traite que les itinéraires ayant le bon numéro de train, celui mémorisé auparavant
                while (iti0.paves_composant_iti.get(0).numero_train1 != memo_numero1
                    && iti0.paves_composant_iti.get(0).numero_train1 != 0) {                                                               //  tant que le premier pavé n'a pas le numéro mémorisé, on l'efface
                    for (int j = 0; j < INDEX_MAX-1; j++) {                                                                                //  il faut decaler la position des lames et l'entrée dans le pave
                        iti0.lames[j]         = iti0.lames[j+1];                                                                           //  la position des lames est decalee
                        iti0.entree_pave[j]   = iti0.entree_pave[j+1];                                                                     //  l'entree_pavé est aussi decalee
                    }
                    iti0.paves_composant_iti.remove(iti0.paves_composant_iti.get(0));                                                      //  effacement du pavé
                }
                iti0.paves_composant_iti.trimToSize();                                                                                     //  on remet au propre les paves_composant_iti
                prolonge_numero_train(iti0);                                                                                               //  on prolonge le numéro de train, ce qui, entre autres, recalcule les points et place bien le train
            }
        }
        if (memo_numero1 == 0) {                                                                                                           //  on ne traite pas au sortir de la boucle précédente : il faut déjà remettre à jour les occupations du train2
            for (Itineraire iti0 : tous_iti) {                                                                                             //  traitement des pavés à deux trains. On balaie tous les itinéraires
                if (iti0.numero_train == memo_numero2 && memo_numero1 == 0) {                                                              //  on ne traite que les itinéraires ayant le memo_train2
                    int index = iti0.paves_composant_iti.size()-1;
                    while (index > -1) {
                      if (!iti0.paves_composant_iti.get(index).occupe) {
                          iti0.paves_composant_iti.get(index).numero_train1 = 0;
                          iti0.paves_composant_iti.remove(index);
                      } else {
                          memo_numero2 = 0;
                          break;
                      }
                      index--;  
                    }
                    iti0.paves_composant_iti.trimToSize();                                                                                 //  on remet au propre les paves_composant_iti
                    prolonge_numero_train(iti0);                                                                                           //  on prolonge le numéro de train, ce qui, entre autres, recalcule les points et place bien le train
                }
            }
        }
        iti_train.pave_debut = iti_train.paves_composant_iti.get(0);                                                                       //  on remet à jour le pave_debut de l'itinéraire
        for (Zone zone1 : toutes_zones) {                                                                                                  //  on balaie toutes les zones
            if (zone1.effacable) {                                                                                                         //  on efface toutes les zones effaçables
                for (Pave pave0 : zone1.paves_composant_zone) {                                                                            //  on libère tous les pavés de la zone à effacer
                    pave0.occupe        = false;
                    pave0.numero_train1 = 0;
                }
                iti_train.zones_composant_iti.remove(zone1);                                                                               //  on retire la zone des zones composant l'itinéraire
            }
        }
        iti_train.zones_composant_iti.trimToSize();                                                                                        //  on remet au propre les zones_composant_iti
        for (Itineraire iti0 : tous_iti) {                                                                                                 //  mise à jour des numéros de pavés
            if (iti0.numero_train > 0) {
                int compteur_paves             = -1;
                int compteur_appareils_de_voie = 0;
                for (Pave pave0 : iti0.paves_composant_iti) {
                      compteur_paves++;
                      if (abs(pave0.numero_train1) == iti0.numero_train || pave0.numero_train1 == 0 || pave0.numero_train1 == -1000) {
                          pave0.carre_manuel[iti0.entree_pave[compteur_paves]] = 0;                                                                                                      //  on ne peut pas avoir de carré manuel en plein milieu de l'itinétraire
                          if (!pave0.appareil_de_voie) {
                              for (int i = compteur_paves; i > compteur_paves-compteur_appareils_de_voie-1; i--) {
                                  iti0.paves_composant_iti.get(i).numero_train1 = iti0.numero_train;                                         //  on donne au pavé le même numero_train que celui de l'itinéraire
                              }
                              compteur_appareils_de_voie = 0;
                          } else {
                              compteur_appareils_de_voie++;
                          }
                      } else {
                          break;
                      }
                }
            }
        }
        //**************************************************************************************************************************************************************************************************************************************************
        //---------------------------------------------------- calcul des ralentissements et des arrets --------------------------------
        Pave pave_vehicule   = iti_train.points_composant_iti.get(debut_train).pave;                                                       //  pave_vehicule est le pavé sur lequel est le véhicule
        int cote_pave        = 1-pave_vehicule.entree_pave;                                                                                //  cote par lequel le train va sortir du le pavé (inverse de l'entrée)
        paveSignalZone       = pave_vehicule.pave_signal_zone[cote_pave];                                                                  //  paveSignalZone est le pavé où est le signal de la zone, dans le sens de l'itinéraire
        position_signal_zone = iti_train.position_signaux_iti.get(0);
        for (int i = 0; i < iti_train.position_signaux_iti.size()-1; i++) {
            if (debut_train < iti_train.position_signaux_iti.get(0)) {                                                                     //  si le train est avant le premier signal
                position_signal_zone    = iti_train.position_signaux_iti.get(0);                                                           //  le signal zone est le premier signal
                position_signal_suivant = iti_train.position_signaux_iti.get(1);                                                           //  le signal suivant est le deuxième signal
                break;                    
            } else {
                if (debut_train > iti_train.position_signaux_iti.get(i) && debut_train <= iti_train.position_signaux_iti.get(i+1)) {       //  si le train est entre deux signaux (entre signal de rang "i" et celui de rang "i+1")
                    position_signal_zone = iti_train.position_signaux_iti.get(i+1);                                                        //  le signal zone est celui de rang "i+1"
                    if (i+2 < iti_train.position_signaux_iti.size()) {                                                                     //  si le signal de rang "i+2" n'est pas le dernier
                        position_signal_suivant = iti_train.position_signaux_iti.get(i+2);                                                 //  le signal suivant est celui de rang "i+2"
                    } else {                                                                                                               //  si le signal de rang "i+1" est le dernier. C'est bien "i+1"
                        position_signal_suivant = -1;                                                                                      //  il n'y a pas de signal suivant
                    }
                    break;
                }
            }
        }
        cote_signal_zone = pave_vehicule.cote_signal_zone[cote_pave];                                                                      //  cote du signal de la zone, vu du pavé du signal, dans le sens de l'itinéraire
        code_signal_zone = paveSignalZone.code_signal[cote_signal_zone];                                                                   //  code du signal de zone, du bon cote
        //---------------------------------------------------- test des differents cas ------------------------------------
        train_pupitre(numero_train);
        numero_pupitre = num_train_pupitre;
        pupitre.bloque[numero_pupitre] = false;
        for (Pave pave0 : iti_train.zone_debut.paves_composant_zone) {
            if (pave0.numero_train2 == numero_train) {                                                                                     //  si on est un train2
                pupitre.bloque[numero_pupitre]  = true;                                                                                    //  on ne peut pas lancer un train2
                hauteur_curseur[numero_pupitre] = 0;
                break;
            }
        }
        if (paveSignalZone != null) {
            //------------------------------------ arrivee sur un signal -------------------------------------------
            if (position_proche == 0) {
                distance_securite = int(150+vitesse*(vitesse+1)/2);                                                                        //  la distance de sécurité donne le nombre de points maximum avant de s'arrêter en fonction de la vitesse
                if (code_signal_zone == SEMAPHORE || code_signal_zone == CARRE || code_signal_zone == CARRE_VIOLET  
                    || debut_train+distance_securite > iti_train.position_signaux_iti.get(iti_train.position_signaux_iti.size()-1)) {      //  le début_train entame la distance de sécurité
                        arret(10);
                } else {
                    if (code_signal_zone == AVERTISSEMENT || code_signal_zone == SEMAPHORE_CLI) {
                        ralentissement(60);                                                                                                //  ralentissement 60
                    } else {
                        //------------------------------- arrivee sur un ralentissement 60 ----------------------------------------
                        if (code_signal_zone == RALENTISSEMENT_CLI                                                                         //  le train peut commencer à ralentir des la zone du signal de RALENTISSEMENT_CLI, juste un peu avant le signal...
                        || (code_signal_zone == RAPPEL_RALENTISSEMENT_CLI)                                                                 //       il continue à ralentir sur la zone RAPPEL_RALENTISSEMENT_CLI)
                        || ralentissement60) {                                                                                             //  le train est actuellement sur un appareil de voie dévié avec un ralentissement 60
                            ralentissement(60);                                                                                            //  ralentissement 60
                        } else {    
                            //------------------------------- arrivee sur un ralentissement 30 ------------------------------------
                            if (code_signal_zone == RALENTISSEMENT                                                                         //  le train peut commencer à ralentir des la zone du signal de RALENTISSEMENT, juste un peu avant le signal...
                            || (code_signal_zone == RAPPEL_RALENTISSEMENT)                                                                 //       il continue à ralentir sur la zone RAPPEL_RALENTISSEMENT
                            || ralentissement30) {                                                                                         //  le train est actuellement sur un appareil de voie dévié avec un ralentissement 30
                                ralentissement(30);                                                                                        //  ralentissement 30
                            } else {
                                acceleration();
                            }
                        }
                    }
                }
            } else {
                position_signal_zone = position_proche;
                nouvelle_position    = position_proche;
                distance_securite    = 80;
                arret(5);
            }
        }
        //------------------------------ gestion du carré manuel ----------------------------------
        if ((iti_train.duree_arret > 0 && !transfert) || (iti_train.iti_suivant == null && !iti_train.cycle)) {
            if (numero_train == iti_train.pave_fin.numero_train1) {
                iti_train.pave_fin.carre_manuel[1-iti_train.pave_fin.entree_pave] = 1;                                                                                    //  on met le carré manuel
            }
        } else {
            if (numero_train == iti_train.pave_fin.numero_train1) {
                iti_train.pave_fin.carre_manuel[1-iti_train.pave_fin.entree_pave] = 0;                                                                                   //  on supprime le carré manuel                
            }
        }
        if (arret_en_gare) {
           iti_train.pave_fin.carre_manuel[1-iti_train.pave_fin.entree_pave] = 0; 
        }
    }
    //------------------------------------------------- ralentissement() -----------------------------------------------------------
    void ralentissement(int _vitesse_ralenti) {
        if (debut_train >= nouvelle_position && vitesse != 0) {
            nouvelle_position = int(position_signal_zone-(position_signal_zone-debut_train)*0.8);
            vitesse  = min(vitesse, int(_vitesse_ralenti+(vitesse-_vitesse_ralenti)*0.4));
        } else {
            if (vitesse < _vitesse_ralenti) {
                acceleration();
            }
        }
    }
    //------------------------------------------------- arret() -----------------------------------------------------------
    void arret(int _vitesse_arret) {
        if (vitesse > 0  || code_signal_zone == SEMAPHORE_CLI || arret_lance || (debut_train+distance_securite < position_signal_zone)) {  //  on ne peut lancer l'arrêt qu'après avoir roulé (particulièrement lorsqu'on pose une loco)
            if ((debut_train+distance_securite > position_signal_zone) || arret_lance) {                                                   //--- si on a entamé la distance de sécurité ou si l'arrêt est déjà lancé
                vitesse--;
                vitesse = max(0, vitesse);                                                                                                 //  la vitesse décroit, mais reste positive
                //---------------------- baisse du curseur si dernier itinéraire -----------
                if ((iti_train.iti_suivant == null && iti_train.pave_fin.occupe)) {                                                        //  pas d'itinéraire suivant et on est sur le pave_fin
                    consigne                        = int(vitesse);                                                                        //    la consigne suit la décroissance de la vitesse
                    hauteur_curseur[numero_pupitre] = consigne;                                                                            //    le curseur suit la consigne
                    iti_train.duree_arret           = 0;
                    duree_restante[numero_pupitre]  = 0;
                    pupitre.horloge[numero_pupitre] = false;
                    //----------------------------------- gérer le rouge clignotant ---------------------------------
                    if (vitesse == 0 && iti_train.pave_rouge_cli != null
                        && numero_train == iti_train.pave_fin.numero_train1 && iti_train.pave_fin.numero_train2 != 0) {                    //  ne sert que si on va abouter des trains. on raisonne à partir du train arrivant uniquement
                                                                                      /*println("-calcule points-rouge clignotant AVANT ------------- ");
                                                                                      for (Itineraire iti0 : tous_iti) {
                                                                                          print("numero_train = "+iti0.numero_train, iti0+" ");
                                                                                          int compt = -1;
                                                                                          for (Pave pave1 : iti0.paves_composant_iti) {
                                                                                              compt++;
                                                                                              print(pave1.numero_train1+" : "+pave1.numero_train2+" | "+pave1.c, pave1.l+" | "+pave1.lames+"["+iti0.lames[compt]+" | "
                                                                                              +pave1.entree_pave+"["+iti0.entree_pave[compt], pave1.occupe+" || ");
                                                                                          }
                                                                                          println(" iti_en_attente = "+iti0.iti_en_attente+" cycle = "+iti0.cycle+" iti_suivant = "+iti0.iti_suivant);
                                                                                          for (Zone zone1 : iti0.zones_composant_iti) {
                                                                                             print(zone1.ID_zone, " ");
                                                                                          }
                                                                                          print(" duree_arret =", iti0.duree_arret);
                                                                                          println();
                                                                                      }
                                                                                      println();*/
                        int numero_train_a_effacer = iti_train.pave_fin.numero_train2;                                                     //  numero du train auquel on va s'abouter
                        Train train_trouve = pupitre.trains[numero_train_a_effacer];                                                       //  c'est le train auquel on va s'abouter
                        iti_train.pave_rouge_cli.rouge_clignotant[iti_train.cote_rouge_cli] = false;                                       //  on efface le feu rouge_clignotant
                        iti_train.pave_rouge_cli = null;
                        compo_train_bis.clear();                                                                                           //  compo_train_bis est le train en cours de construction
                        if (PVector.dist(coord_debut_train, train_trouve.coord_debut_train) >
                            PVector.dist(coord_debut_train, train_trouve.coord_fin_train)) {
                            //---------------------------- on est plus près de la fin du train --------------------------
                            //-------------------------- on ajoute les véhicules du train_trouve en partant du début ------------------------
                            for (Vehicule veh0 : train_trouve.compo_train) {
                                compo_train_bis.add(veh0);
                            }                                                                                                              //  à ce stade, le train est composé uniquement du train_trouve
                            //-------------------------- on recalcule le point de début du train trouvé ------------------------------------------
                            for (int pos = 0; pos < iti_train.points_composant_iti.size(); pos++) {
                                if (PVector.dist(iti_train.points_composant_iti.get(pos).coord, train_trouve.coord_debut_train) < 0.1) {
                                    compo_train_bis.get(0).position = pos;
                                    //debut_train                     = pos;
                                    break;
                                }
                            }
                                                                                                //println("près de la fin : compo_train_bis.get(0).position =", compo_train_bis.get(0).position, "size =", iti_train.points_composant_iti.size());
                                                                                                //println("coord_debut_train = ", coord_debut_train);
                        } else {                                                                                                           //----- on aboute le train par l'arrière : on garde le sens d'affichage du train arrivant
                            //-------------------------- on est plus près du début du train ------------------------
                            //-------------------------- on ajoute les véhicules du train_trouve en partant de la fin -----------------------
                            int index = train_trouve.compo_train.size()-1;
                            while (index > -1) {
                                compo_train_bis.add(train_trouve.compo_train.get(index));
                                index--;
                            }
                            for (Vehicule veh0 : compo_train_bis) {
                                veh0.image_inverse = true;
                            }
                            //-------------------------- on recalcule le point de fin du train trouvé ------------------------------------------
                            for (int pos = 0; pos < iti_train.points_composant_iti.size(); pos++) {
                                if (PVector.dist(iti_train.points_composant_iti.get(pos).coord, train_trouve.coord_fin_train) < 0.1) {
                                    compo_train_bis.get(0).position = pos;
                                    //debut_train                     = pos;
                                    break;
                                }
                            }
                                                                                                //println("près du début : compo_train_bis.get(0).position =", compo_train_bis.get(0).position, "size =", iti_train.points_composant_iti.size());
                                                                                                //println("coord_debut_train = ", coord_debut_train);
                        }
                        //-------------------------- on ajoute les véhicules du train -------------------------
                        index = 0;
                        while (index < compo_train.size()) {
                            compo_train_bis.add(compo_train.get(index));
                            index++;
                        }
                        compo_train.clear();
                        for (Vehicule veh0 : compo_train_bis) {
                            veh0.attele_fin = true;
                            compo_train.add(veh0);
                        }
                                                                                              //println("AVANT : iti_train =", iti_train, "iti_train.numero_train =", iti_train.numero_train, "numero_pupitre =", numero_pupitre, "train =", train, "train_trouve =", train_trouve);
                                                                                              //println("debut_train =", debut_train);
                                                                                              //println("compo_train =", compo_train, iti_train.points_composant_iti.size(), "compo_train_bis.get(0).position =", compo_train_bis.get(0).position);
                        supprime_train(numero_train_a_effacer);
                        choix_train                     = -1;
                        numero_attelage                 = 0;
                        position_proche                 = 0;                                                                               //  pour pouvoir redémarrer en tenant compte des signaux
                        iti_train.duree_arret           = 0;
                        compo_train_bis.clear();
                        nb_vehicules = compo_train.size();
                        if (numero_train > numero_train_a_effacer) {
                            numero_train--;
                        }
                        pupitre.horloge[numero_pupitre] = false;
                        duree_restante[numero_pupitre]  = 0;
                        debut_train = compo_train.get(0).position;
                        for (Pave pave0 : iti_train.paves_composant_iti) {
                            if (pave0.feu_noir[0]) {
                                pave0.feu_noir[0]       = false;
                                pave0.feu_clignotant[0] = false;
                            }
                            if (pave0.feu_noir[1]) {
                                pave0.feu_noir[1]       = false;
                                pave0.feu_clignotant[1] = false;
                            }
                        }
                                                                                              //println("APRES : iti_train =", iti_train, "iti_train.numero_train =", iti_train.numero_train, "numero_pupitre =", numero_pupitre, "train =", train, "train_trouve =", train_trouve);
                                                                                              //println("pupitre.trains[iti_train.numero_train] =", pupitre.trains[iti_train.numero_train]);
                                                                                              //println("debut_train =", debut_train);
                                                                                              //println("compo_train =", compo_train);
                        //debut_train = pupitre.trains[iti_train.numero_train+1].debut_train;
                                                                                              //println("train+1 =", pupitre.trains[iti_train.numero_train+1], "debut_train nouveau +1 =", debut_train,
                                                                                              //"iti_train =", iti_train, "pupitre.trains[iti_train.numero_train+1].iti_train =", pupitre.trains[iti_train.numero_train+1].iti_train);
                        /*for (int pos = 0; pos < iti_train.points_composant_iti.size(); pos++) {
                            if (PVector.dist(iti_train.points_composant_iti.get(pos).coord,                                                //  on recherche la position future du train sur le nouvel itinéraire
                                coord_debut_train) < 0.1) {                                                                                       //  elle correspond à debut_train
                                debut_train = pos;
                                break;
                            }
                        }*/
                                                                                              //println("debut_train calculé =", debut_train);
                                                                                      /*println("-calcule points-rouge clignotant APRES ------------- ");
                                                                                      for (Itineraire iti0 : tous_iti) {
                                                                                          print("numero_train = "+iti0.numero_train, iti0+" ");
                                                                                          int compt = -1;
                                                                                          for (Pave pave1 : iti0.paves_composant_iti) {
                                                                                              compt++;
                                                                                              print(pave1.numero_train1+" : "+pave1.numero_train2+" | "+pave1.c, pave1.l+" | "+pave1.lames+"["+iti0.lames[compt]+" | "
                                                                                              +pave1.entree_pave+"["+iti0.entree_pave[compt], pave1.occupe+" || ");
                                                                                          }
                                                                                          println(" iti_en_attente = "+iti0.iti_en_attente+" cycle = "+iti0.cycle+" iti_suivant = "+iti0.iti_suivant);
                                                                                          for (Zone zone1 : iti0.zones_composant_iti) {
                                                                                             print(zone1.ID_zone, " ");
                                                                                          }
                                                                                          print(" duree_arret =", iti0.duree_arret);
                                                                                          println();
                                                                                      }
                                                                                      println();*/
                    }
                }
                //--------------------- lancement de l'arrêt en gare ----------------------
                if (vitesse < 2 && !iti_train.iti_en_attente && !arret_lance && debut_train+200 > position_signal_zone) {                  //  si le train est arrêté, qu'on a atteint la fin de l'itinéraire et que l'arrêt n'est pas déjà lancé
                    arret_lance          = true;                                                                                           //  on met l'arret_lance à true pour ne lancer l'arrêt qu'une seule fois
                    ancien_arret_en_gare = millis();                                                                                       //  il n'y a donc qu'un seul ancien_arret_en_gare
                }
                nouvel_arret_en_gare     = millis();                                                                                       //  le temps s'écoule...
                if ((vitesse == 0 && arret_lance)) {                                                                                       //  si on est à l'arrêt, et qu'on a lancé l'arrêt OU si on redémarre directement
                    if (((nouvel_arret_en_gare - ancien_arret_en_gare) > 1000*iti_train.duree_arret)) {                                    //  on regarde si on a atteint la durée d'arrêt OU redémarrage direct
                        arret_lance                     = false;                                                                           //  on n'a plus d'arrêt lancé
                        iti_train.pave_fin.carre_manuel[1-iti_train.pave_fin.entree_pave] = 0;                                                                           //  on efface le carré manuel à l'extrémité de l'itinéraire en cours : on suit maintenant la signalisation
                        arret_en_gare                   = true;
                        pupitre.horloge[numero_pupitre] = false;
                    } else {
                        if (iti_train.duree_arret != 0) {
                            duree_restante[numero_pupitre]  = int((1000*iti_train.duree_arret-(nouvel_arret_en_gare - ancien_arret_en_gare))*127/(1000*iti_train.duree_arret));
                            max_duree[numero_pupitre]       = iti_train.duree_arret;
                            pupitre.horloge[numero_pupitre] = true;
                        }
                    }
                }
            } else {
                if (debut_train > nouvelle_position && vitesse != 0) {                                                                     //--- si on est simplement en train de ralentir devant un feu d'arrêt
                    nouvelle_position = int(position_signal_zone-(position_signal_zone-debut_train)*0.8);                                  //  calcul de la nouvelle position où la vitesse va décroître
                    float vitesse_cible = min(vitesse, _vitesse_arret+(vitesse-_vitesse_arret)*0.4);                                       //  clacul de la nouvelle vitesse
                    if (vitesse > vitesse_cible) {                                                                                         //  on décroît de 4 tant qu'on a pas atteint la vitesse cible
                        vitesse -= 4;
                    }
                } else {
                    vitesse = min(2*_vitesse_arret, consigne);
                }
            }
        }
    }
    //----------------------------------------------- acceleration() ----------------------------------------------------------------------------
    void acceleration() {
        //------------------------- test d'un éventuel train n°2 -------------------
        if (!pupitre.bloque[numero_pupitre]) {
            vitesse = min(vitesse+1, consigne);                                                                                            //  la vitesse du train1 croît, mais ne peut pas dépasser la consigne
        }
        //-------------------------- effacement des iti tempo de ce train --------------------
        if (vitesse > 0 && !efface_iti_tempo) {                                                                                            //  effacement des iti_tempo lorsqu'on accélère la première fois 
            efface_iti_tempo = true;                                                                                                       //  on n'efface qu'une fois
            efface_iti_tempo(numero_train);                                                                                                //  on efface tous les iti_tempo ayant ce numéro de train
            for (Itineraire iti0 : tous_iti) {
                if (abs(iti0.numero_train) == abs(iti_train.numero_train)) {                                                               //  si le train qui démarre a le même numero_train que l'itinéraire courant
                    for (Pave pave0 : iti0.paves_composant_iti) {                                                                          //  on efface tous les feux noirs de l'itinéraire
                        if (pave0.feu_noir[0]) {
                            pave0.feu_noir[0]       = false;
                            pave0.feu_clignotant[0] = false;
                        }
                        if (pave0.feu_noir[1]) {
                            pave0.feu_noir[1]       = false;
                            pave0.feu_clignotant[1] = false;
                        }
                    }
                }
            }
        }
    }
    //------------------------------------- retourne_train() ----------------------------------------
    void retourne_train() {
        compo_train_bis.clear();
        //-------------------------- on ajoute les véhicules du train en partant de la fin -------------------------
        int index = compo_train.size()-1;
        while (index > -1) {
            compo_train_bis.add(compo_train.get(index));
            index--;
        }
        compo_train.clear();
        for (Vehicule veh0 : compo_train_bis) {
            veh0.attele_fin = true;
            compo_train.add(veh0);
        }
        compo_train.get(compo_train.size()-1).attele_fin = false;
        debut_train = compo_train.get(0).position;
        for (Vehicule veh0 : compo_train) {
            veh0.image_inverse = !veh0.image_inverse;
        }
    }
}
//------------------------------------------- supprime_train() ------------------------------------------
void supprime_train(int _numero_train) {
    supp_en_cours = true;
    for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {
        train = pupitre.trains[numero_train];
        println(train);
    }
                                                                                      /*println("-calcule points-supprime AVANT ------------- ");
                                                                                      for (Itineraire iti0 : tous_iti) {
                                                                                          print("numero_train = "+iti0.numero_train, iti0+" ");
                                                                                          int compt = -1;
                                                                                          for (Pave pave1 : iti0.paves_composant_iti) {
                                                                                              compt++;
                                                                                              print(pave1.numero_train1+" : "+pave1.numero_train2+" | "+pave1.c, pave1.l+" | "+pave1.lames+"["+iti0.lames[compt]+" | "
                                                                                              +pave1.entree_pave+"["+iti0.entree_pave[compt], pave1.occupe+" || ");
                                                                                          }
                                                                                          println(" iti_en_attente = "+iti0.iti_en_attente+" cycle = "+iti0.cycle+" iti_suivant = "+iti0.iti_suivant);
                                                                                          for (Zone zone1 : iti0.zones_composant_iti) {
                                                                                             print(zone1.ID_zone, " ");
                                                                                          }
                                                                                          print(" duree_arret =", iti0.duree_arret);
                                                                                          println();
                                                                                      }
                                                                                      println();
                                                                                      println(liste_trains);
                                                                                      for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {
                                                                                          train_courant = pupitre.trains[numero_train];
                                                                                          println(train_courant, "ancien numero_train , numero_pupitre =", train_courant.numero_train , train_courant.numero_pupitre);
                                                                                      }
                                                                                      for (int numero_train = 1; numero_train < liste_trains.size(); numero_train++) {
                                                                                          if (numero_train >= _numero_train) {
                                                                                              pupitre.trains[numero_train] = pupitre.trains[numero_train+1];
                                                                                          }
                                                                                      }*/
                                                                                                              println("liste_trains AVANT : ",liste_trains);
    train = pupitre.trains[_numero_train];
    boolean moteur1 = false;
    for (int i = 0; i < train.compo_train.size(); i++) {
        if (train.compo_train.get(i).moteur) {
            moteur1 = true;
            break;
        }                                
    }
    //------------ efface le train de la liste ------------------
    index = liste_trains.size()-1;                                                                                                         //  on part de la fin
    while (index > -1) {
        if (index+1 == _numero_train) {                                                                                                    //  index+1 correspond à un numéro de train. Si c'est le bon train...
            liste_trains.remove(index);                                                                                                    //  ... on efface le train
            break;                                                                                                                         //  on s'arrête de remonter dans la liste. C'est fini
        }
        index--;                                                                                                                           //  on remonte d'une ligne
    }    //----------- efface les itineraires de abs(numero_train) = _numero_train ----------
                                                                                                              println("liste_trains APRES : ",liste_trains);
    int index  = tous_iti.size()-1;
    while (index > -1) {
        Itineraire iti0 = tous_iti.get(index);
                                                                                        println("supprime : test du train n°", iti0.numero_train, "iti0 =", iti0);
        if (abs(iti0.numero_train) == _numero_train) {                                                                                      //  on ne supprime que le train qu'on a choisi
                                                                                        println("on a bien abs(iti0.numero_train) =", abs(iti0.numero_train), " == _numero_train", _numero_train);                       
            iti0.efface_itineraire();
            for (Pave pave0 : iti0.paves_composant_iti) {
                if (pave0.numero_train1 == _numero_train) {
                    pave0.occupe                = false;
                    pave0.numero_train1         = 0;
                    pave0.numero_train2         = 0;
                    if (pave0.feu_noir[0]) {
                        pave0.feu_noir[0]       = false;
                        pave0.feu_clignotant[0] = false;
                    }
                    if (pave0.feu_noir[1]) {
                        pave0.feu_noir[1]       = false;
                        pave0.feu_clignotant[1] = false;
                    }
                    pave0.carre_manuel[0] = 0;
                    pave0.carre_manuel[1] = 0;
                }
            }
            for (Zone zone0 : iti0.zones_composant_iti) {
                zone0.occupee = false;
            }
            tous_iti.remove(index);
        }
        index--;
    }
    tous_iti.trimToSize();
    //---------------------- renuméroter les numeros de train des itinéraires et des pavés -------------------
    for (Itineraire iti0 : tous_iti) {
        if (abs(iti0.numero_train) > _numero_train) {
            iti0.numero_train   = iti0.numero_train-(iti0.numero_train/abs(iti0.numero_train));                                            //  (iti0.numero_train/abs(iti0.numero_train)) = +/- 1
            for (Pave pave0 : iti0.paves_composant_iti) {                                                                                  //  met à jour aussi les numéros de train dans les pavés
                pave0.numero_train1 = iti0.numero_train;
                if (pave0.numero_train2 == _numero_train) {
                    pave0.numero_train2 = 0;
                } else {
                    if (pave0.numero_train2 > _numero_train) {
                        pave0.numero_train2 = pave0.numero_train2-(pave0.numero_train2/abs(pave0.numero_train2));
                    }
                }
            }
        }
    }
    index = -1;
    for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {
        index++;
        train = pupitre.trains[numero_train];
        if (numero_train >= _numero_train) {
            pupitre.trains[numero_train] = pupitre.trains[numero_train+1];
            if (moteur1) {
                liste_trains.set(index, liste_trains.get(index)-1);
            }
        }
    }
                                                                                                              println("liste_trains FIN : ",liste_trains);
    for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {
        train = pupitre.trains[numero_train];
        println(train);
    }
    affiche_trains               = false;
    supprime_train               = false;
    texte_affiche_train          = ".";
    couleur_affiche_train        = BLANC;
    numero_point_train           = -1;
    supp_en_cours = false;
}
